From 10733787c5945fa7187314e221015cfbc019a99a Mon Sep 17 00:00:00 2001
From: Celeborn2BeAlive <laurent.noel.c2ba@gmail.com>
Date: Fri, 1 Jul 2016 16:54:34 +0200
Subject: [PATCH] [Shining] Patch for Windows compilation

---
 src/cmake/externalpackages.cmake | 3 +++
 src/liboslcomp/oslgram.y         | 7 +++++++
 src/liboslcomp/osllex.l          | 7 +++++++
 src/liboslexec/osogram.y         | 7 +++++++
 src/liboslexec/osolex.l          | 7 +++++++
 5 files changed, 31 insertions(+)

diff --git a/src/cmake/externalpackages.cmake b/src/cmake/externalpackages.cmake
index 827ca59..9463ea8 100644
--- a/src/cmake/externalpackages.cmake
+++ b/src/cmake/externalpackages.cmake
@@ -254,6 +254,9 @@ if ((LLVM_LIBRARY OR LLVM_STATIC) AND LLVM_INCLUDES AND LLVM_DIRECTORY AND LLVM_
                      OUTPUT_VARIABLE LLVM_LIBRARY
                      OUTPUT_STRIP_TRAILING_WHITESPACE)
     string (REPLACE " " ";" LLVM_LIBRARY ${LLVM_LIBRARY})
+    string(REPLACE "\\" "/" LLVM_LIBRARY ${LLVM_LIBRARY})
+    string(REPLACE "libLL" "LL" LLVM_LIBRARY ${LLVM_LIBRARY})
+    string(REPLACE ".a" ".lib;" LLVM_LIBRARY ${LLVM_LIBRARY})
   endif ()
   if (NOT LLVM_FIND_QUIETLY)
       message (STATUS "LLVM OSL_LLVM_VERSION = ${OSL_LLVM_VERSION}")
diff --git a/src/liboslcomp/oslgram.y b/src/liboslcomp/oslgram.y
index 53b8c71..13d2fa3 100644
--- a/src/liboslcomp/oslgram.y
+++ b/src/liboslcomp/oslgram.y
@@ -41,6 +41,13 @@ OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 #include <stack>
 #include <string>
 
+#ifdef _WIN32
+#include <io.h>
+#define isatty _isatty
+#else
+#include <unistd.h>
+#endif
+
 #include "oslcomp_pvt.h"
 
 #undef yylex
diff --git a/src/liboslcomp/osllex.l b/src/liboslcomp/osllex.l
index 37c7bdf..ab920d1 100644
--- a/src/liboslcomp/osllex.l
+++ b/src/liboslcomp/osllex.l
@@ -91,6 +91,13 @@ CPLUSCOMMENT    \/\/.*\n
 #include <vector>
 #include <string>
 
+#ifdef _WIN32
+#include <io.h>
+#define isatty _isatty
+#else
+#include <unistd.h>
+#endif
+
 #include "oslcomp_pvt.h"
 
 using namespace OSL;
diff --git a/src/liboslexec/osogram.y b/src/liboslexec/osogram.y
index ad55438..6e2fd02 100644
--- a/src/liboslexec/osogram.y
+++ b/src/liboslexec/osogram.y
@@ -39,6 +39,13 @@ OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 #include <vector>
 #include <string>
 
+#ifdef _WIN32
+#include <io.h>
+#define isatty _isatty
+#else
+#include <unistd.h>
+#endif
+
 #include "osoreader.h"
 
 #undef yylex
diff --git a/src/liboslexec/osolex.l b/src/liboslexec/osolex.l
index 2414e8b..4061695 100644
--- a/src/liboslexec/osolex.l
+++ b/src/liboslexec/osolex.l
@@ -91,6 +91,13 @@ HINTPATTERN     \%{IDENT}(\{({IDORLITERAL}(\,{IDORLITERAL})*)?\})?
 #include <vector>
 #include <string>
 
+#ifdef _WIN32
+#include <io.h>
+#define isatty _isatty
+#else
+#include <unistd.h>
+#endif
+
 #include <OpenImageIO/ustring.h>
 #include <OpenImageIO/strutil.h>
 
-- 
2.8.1.windows.1

